package client;

import java.net.*;
import java.io.*;

import common.*;

public class Client extends Thread {
  private BufferedWriter writer;
  private BufferedReader reader;
  
  private static final String[] lines = {
    "login bart safe",
    "log den frste linie",
    "log dette er en anden linie",
    "switch homer secure",
    "log kan jeg det?",
    "get 1",
    "logout"
  };
  
  public void run() {
    try {
      Socket connection = new Socket( "127.0.0.1", 6010 );
      System.out.println( "[Client] Connection opened" );
    
      writer = new BufferedWriter(
                 new OutputStreamWriter(
                   connection.getOutputStream() ) );
      
      reader = new BufferedReader(
                 new InputStreamReader(
                   connection.getInputStream() ) );
      
      Sleeper.nap(); // vre sikker p server er online
      
      for ( int i=0; i<lines.length; i++ ) {
        sendLine( lines[i] );
        
        if ( isError() )
          System.out.println( "[Client] der skete en fejl" );

        Sleeper.sleep( 1 );  
      }

      writer.close();
      System.out.println( "[Client] Connection closed" );
    }
    catch ( IOException e ) {
      System.out.println( "[Client] I/O error" );
    }
  }
  
  private boolean isError() throws IOException {
    return readLine().startsWith( "ERROR:" );
  }
  
  private String readLine() throws IOException {
    String line = reader.readLine();
    System.out.println( "[Client] received: " + line );
    
    if ( line == null )
      throw new IOException( "End of stream" );
    return line;
  }
  
  private void sendLine( String line )
    throws IOException
  {
    System.out.println( "[Client] sending line: " + line );
    
    writer.write( line );
    writer.newLine();
    writer.flush();
    
    Sleeper.nap();
  }
}
