package server;

public abstract class Event {
  
  public static final int LOGIN_EVENT   = 0;
  public static final int LOGOUT_EVENT  = 1;
  public static final int LOG_EVENT     = 2;
  public static final int GET_EVENT     = 3;
  public static final int SWITCH_EVENT  = 4;
  
  public static final int ANY_EVENT     = 5;
  
  public static final int FIRST_EVENT   = LOGIN_EVENT;
  public static final int LAST_EVENT    = SWITCH_EVENT;
  
  public static final int UNKNOWN_EVENT = -1;
  
  public static String eventToName( int event ) {
    switch ( event ) {
      case 0: return "LOGIN_EVENT";
      case 1: return "LOGOUT_EVENT";
      case 2: return "LOG_EVENT";
      case 3: return "GET_EVENT";
      case 4: return "SWITCH_EVENT";
      
      case 5: return "ANY_EVENT";

      default: return "<unknown event: " + event + ">";
    }
  }
  
  public static int nameToEvent( String name ) {
    String upperCase = name.toUpperCase();
    
    if ( !upperCase.endsWith( "_EVENT" ) )
      upperCase += "_EVENT";
    
    if ( upperCase.startsWith( "LOGIN_EVENT" ) )
      return LOGIN_EVENT;
    else if ( upperCase.startsWith( "LOGOUT_EVENT" ) )
      return LOGOUT_EVENT;
    else if ( upperCase.startsWith( "LOG_EVENT" ) )
      return LOG_EVENT;
    else if ( upperCase.startsWith( "GET_EVENT" ) )
      return GET_EVENT;
    else if ( upperCase.startsWith( "SWITCH_EVENT" ) )
      return SWITCH_EVENT;
    else if ( upperCase.startsWith( "ANY_EVENT" ) )
      return ANY_EVENT;
    else
      return UNKNOWN_EVENT;
  }
}