package server;

import java.net.*;
import java.io.*;

public class Handle {
  private Socket socket;
  private BufferedReader reader;
  private BufferedWriter writer;
  
  public Handle( Socket socket ) throws IOException {
    this.socket = socket;
    
    reader = new BufferedReader(
               new InputStreamReader(
                 socket.getInputStream() ) );
                 
    writer = new BufferedWriter(
               new OutputStreamWriter(
                 socket.getOutputStream() ) );
  }
  
  public String readLine() {
    try {
      return reader.readLine();
    }
    catch ( IOException e ) {
      // simplificering af eksemplet
      e.printStackTrace();
      return null;
    }
  }
  
  public void sendError( String message ) {
    writeLine( "ERROR: " + message );
  }
  
  public void sendOk( String message ) {
    writeLine( "OK: " + message );
  }
  
  private void writeLine( String line ) {
    try {
      writer.write( line );
      writer.newLine();
      writer.flush();
      System.out.println( "[Handle] send: " + line );
    }
    catch ( IOException e ) {
      // simplificering af eksemplet
      e.printStackTrace();
    }
  }
  
  public boolean ready() {
    try {
      return reader.ready();
    }
    catch ( IOException e ) {
      // simplificering af eksemplet
      e.printStackTrace();
      return false;
    }
  }
}