package server;

import java.net.*;
import java.io.*;

import server.handler.*;

public class Server extends Thread {
  private boolean stop;
  
  public Server() {
    stop = false;
  }
  
  public void run() {
    try {
      ServerSocket server = new ServerSocket( 6010 );
      server.setSoTimeout( 100 ); // 1/10 sekund
      System.out.println( "[Server] Online" );
      
      while ( !stop ) {
        try {
          Socket socket = server.accept();
          
          Reactor.i().addHandler( new Handle( socket ),
                                  new LoginHandler(),
                                  Event.LOGIN_EVENT );
        }
        catch ( SocketTimeoutException e ) {
          // ignore
        }
      }

      System.out.println( "[Server] Offline" );
    }
    catch ( IOException e ) {
      System.out.println( "[Server] I/O error" );
    }
  }
  
  public void shutdown() {
    stop = true;
  }
}
