package server.handler;

import server.*;

public abstract class AccessHandler implements EventHandler {
  
  public boolean authentication( Handle handle, int event, String[] tokens ) {
    try {
      String userid = tokens[1];
      String password = tokens[2];
      
      EventHandler handler=null;
      
      if ( !Users.loginOkay( userid, password ) ) {
        handle.sendError( "command failed" );
        return false;
      } else {
        if ( Users.writeRight( userid ) ) {
          // read/write
          handle.sendOk( "You have read/write access" );
          handler = new ReadWriteHandler();
        } else {
          // read only
          handle.sendOk( "You have read only access" );
          handler = new ReadOnlyHandler();
        }   
        
        Reactor.i().addHandler( handle, handler, Event.LOG_EVENT );
        Reactor.i().addHandler( handle, handler, Event.GET_EVENT );
      }
      // user logged in
      
      return true;
    }
    catch ( IndexOutOfBoundsException e ) {
      handle.sendError( "Userid and/or password missing" );
    }

    return false;
  }
}