package server.handler;

import server.*;

public abstract class LogHandler implements EventHandler {
  
  public void handleEvent( Handle handle, int event, String[] tokens ) {
    if ( event == Event.LOG_EVENT )
      handleLogEvent( handle, tokens );
    else if ( event == Event.GET_EVENT )
      handleGetEvent( handle, tokens );
  }
  
  public abstract void handleLogEvent( Handle handle, String[] tokens );
  
  public void handleGetEvent( Handle handle, String[] tokens ) {
    try {
      handle.sendOk( Log.i().get( Integer.parseInt( tokens[1] ) ) );
    }
    catch ( NumberFormatException e ) {
      handle.sendError( "syntax error in number" );
    }
    catch ( IndexOutOfBoundsException e ) {
      handle.sendOk( "missing number" );
    }
  }
}