package server.handler;

import server.*;

public class SwitchHandler extends AccessHandler {
  
  public void handleEvent( Handle handle, int event, String[] tokens ) {

    EventHandler logHandler = Reactor.i().removeHandler( handle, Event.LOG_EVENT );
    EventHandler getHandler = Reactor.i().removeHandler( handle, Event.GET_EVENT );
    
    if ( event == Event.SWITCH_EVENT ) {
      if ( !authentication( handle, event, tokens ) ) {
        // switch failed
        Reactor.i().addHandler( handle, logHandler, Event.LOG_EVENT );
        Reactor.i().addHandler( handle, getHandler, Event.GET_EVENT );
      }
    }
  }
}